﻿Type=Service
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
#End Region


Sub Process_Globals
	Dim Discorso 		As String 
	Dim TTS2  			As TTS 
	Dim StaParlando		As Boolean  ' non so ancora se serve
	'Dim TipoDiscorso	As String   ' "SU" o "GIU" 
	'Dim Notification2 	As Notification
End Sub
Sub Service_Create
    Log("PRONUNCIA2 created")
    If TTS2.IsInitialized = False Then
       TTS2.Initialize("TTS2")
	   Log ("inizializzo TTS2")
    End If
    TTS2.SetLanguage("it","IT")
	'Notification2.Initialize
	'Notification2.Vibrate = False 
	'Notification2.Sound = False
 End Sub

Sub Service_Start (StartingIntent As Intent)
    Log("PROUNCIA2 started")
	'PWS.PartialLock
	'Service.StartForeground (1,Notification2) OK in REM
	StaParlando=True 
End Sub

Sub Service_Destroy
    Log("PRONUNCIA2 destroyed")
	If TTS2.IsInitialized Then TTS2.Release
	StaParlando=False 
End Sub
'
Sub TTS2_Ready (Success As Boolean)
	Log("TTS2_Ready") 
	Discorso=Discorso & " /P0"
    If Success Then
		PronunciaDiscorso(Discorso)
    Else
		ToastMessageShow ("Errore inizializzando il motore TTS",True) 
    End If
End Sub

Sub PronunciaDiscorso (Msg As String)
	Dim ele() 					As String 
	Dim i						As Int 
	Dim S						As String 
	Dim Posiz					As Int 
	Dim TotFrasi				As Int
	Dim NumFrase 				As Int  
	Dim Condiz As Boolean 
	
	Condiz=False 

 	ele = Regex.Split(" /P",Msg)
	TotFrasi=ele.Length-1 
	
	'--- avvio la procedura di speak, frase per frase
	For i=0 To TotFrasi 
		Posiz=ele(i).IndexOf2 (" ",0)
		If Posiz>-1 Then 
			S=ele(i).SubString2 (0,Posiz) 
			If S<>"" Then 
				If IsNumber(S) Then 
					ele(i)=ele(i).SubString(Posiz+1)
					Dim T As Timer 
					Main.InAttesa=True   
					T.Initialize ("Attendi",S)
					T.Enabled = True 
	               	Do Until Main.InAttesa=True 
					Loop            
					T.Enabled = False  				
					If ele(i).Trim<>"" Then  
						NumFrase=NumFrase+1
						TTS2.Speak(ele(i), Condiz)
						If TotFrasi=NumFrase Then TestaFineParole 
					End If 	
				Else
					If ele(i).Trim<>"" Then  
						NumFrase=NumFrase+1
						TTS2.Speak(ele(i), Condiz)
						If TotFrasi=NumFrase Then TestaFineParole 
					End If 	
	            End If 	
			End If	
		Else 
			If ele(i).Trim<>"" Then  
				NumFrase=NumFrase+1
				TTS2.Speak(ele(i), Condiz)
				If TotFrasi=NumFrase Then TestaFineParole 
			End If 			
		End If 
		DoEvents 
		If StaParlando=False Then 
			i=ele.Length-1	
			TestaFineParole 
			Exit 
		End If
	Next 

End Sub 


Sub TestaFineParole
    '--- Testa solo l'ULTIMA frase e, quando essa è finita, nasconde l'altoparlante

	Dim jTTS As JavaObject=TTS2
'	
    Do Until jTTS.RunMethod("isSpeaking", Null) = False  
		DoEvents
	Loop  
	Log ("------------------------------")
	Log ("fine di tutte le frasi")
	Log ("------------------------------")
	
	CallSub (Main,"FineDiscorso")  ' ri-visualizzo IVDocente o IVClasse
	TTS2.Stop 
	StopService ("Pronuncia2")  
	StaParlando=False 
End Sub 
